--> CHANGE ME
local notification_library_name = "notifications" -- ../scripts/include/(notification name)
local chat_library_name = "chat" -- ../scripts/include/(chat print name)

--> Libraries
local nstat, notifications = pcall(function () return require(notification_library_name) end)
local cstat, chat = pcall(function () return require(chat_library_name) end)

--> ffi funcs.
local set_clipboard = function (text) ffi.cast("void(__thiscall*)(void*, const char*, int)", memory.get_vfunc(memory.create_interface("vgui2.dll", "VGUI_System010"), 9))(ffi.cast("void*",0), text, #text) end

--> UI
local ui = {

    logsEnable = menu.add_checkbox("中文击中日志", "启用日志", true),
    menu.add_text("中文击中日志", " "),
    menu.add_text("中文击中日志", "日志"),
    menu.add_separator("中文击中日志"),
    logsAimbot = menu.add_multi_selection("中文击中日志", "瞄准日志", {"命中", "预计命中", "扩散", "解析", "预判", "未注册", "死亡", "遮挡", "外推", "其他"}),
    logsTo = menu.add_multi_selection("中文击中日志", "位置", {"左上角", "通知", "聊天框(本地)", "聊天框(全局)"}),
    logsNotifyMiss = menu.add_text("中文击中日志", "找不到 ".. notification_library_name .. " 库"),
    logsChatMiss = menu.add_text("中文击中日志", "找不到 '" .. chat_library_name .. " 库"),
    menu.add_text("中文击中日志", " "),
    menu.add_text("中文击中日志", "设置"),
    menu.add_separator("中文击中日志"),
    logsTag = menu.add_checkbox("中文击中日志", "在消息前添加标签"),
    logsCopy = menu.add_checkbox("中文击中日志", "自动复制最后一条消息"),
    logsNotifySpeed = menu.add_slider("中文击中日志", "通知显示时间", 0, 10, 1, 0, "秒"),
    logsChatColor = menu.add_selection("中文击中日志", "聊天框颜色", {"Default", "white", "green", "red", "yellow", "blue", "purple", "lightred", "orange"}),

    menu.add_text("更新日志", "[26.4.2022]"),
    menu.add_text("更新日志", " - 增加 \"未注册射击\" 在 \"射击\" 日志里"),
    menu.add_text("更新日志", " - 在消息前添加标签(好像没什么用？)"),
    menu.add_text("更新日志", " - 完全重做的消息"),
    menu.add_text("更新日志", " - 完全重做未命中日志"),
    menu.add_text("更新日志", " - 稍微改变了菜单"),
    menu.add_text("更新日志", " - 改变了 \"日志\" 选择 (现在为 \"瞄准日志\")"),
    menu.add_text("更新日志", " - \"聊天框(全局)\" 现在适用于每种消息类型"),
    menu.add_text("更新日志", " - \"死亡\" 在选择中 用于本地和目标死亡"),
    menu.add_text("更新日志", "Lua翻译:Sa3ura 可能会有很多bug"),
    menu.add_text("更新日志", "毕竟花了几分钟翻译过来QAQ"),
    menu.add_text("更新日志", "原作者开源链接"),
    menu.add_text("更新日志", "https://primordial.dev/resources/ragebot-logs-notification-chat.196/"),
}

ui.logsNotifyMiss:set_visible(false)
ui.logsChatMiss:set_visible(false)

--> Func. for checking lists
function Set (list)
    local set = {}
    for _, l in ipairs(list) do set[l] = true end
    return set
end

--> Variables
local data = {

    hitgroupName = {"全身", "头", "胸", "胃", "左臂", "右臂", "左腿", "右腿", "脖子", "Gear"},
    missReason = Set {"spread", "spread (missed safe)", "resolver", "prediction error", "server rejection", "ping (local death)", "ping (target death)", "occlusion", "extrapolation"}
}

function aikoLogs_Init()

    if not nstat and string.find(notifications, "module '".. notification_library_name .. "' not found: unknown module, make sure the file is in primordial/scripts/include") then

        ui.logsTo:set_items({ui.logsTo:get_item_name(1), "Notifications - missing library", ui.logsTo:get_item_name(3), ui.logsTo:get_item_name(4)})
        ui.logsNotifyMiss:set_visible(true)
    end
        
    if not cstat and string.find(chat, "module '".. chat_library_name .. "' not found: unknown module, make sure the file is in primordial/scripts/include") then
        
        ui.logsTo:set_items({ui.logsTo:get_item_name(1), ui.logsTo:get_item_name(2), "Chat (local) - missing library", ui.logsTo:get_item_name(4)})
        ui.logsChatMiss:set_visible(true)
    end
end

--> Paint Callback
local function on_paint()

    if(ui.logsTo:get("通知")) then ui.logsNotifySpeed:set_visible(true)
    else ui.logsNotifySpeed:set_visible(false)  end

    if(ui.logsTo:get("聊天框(本地)")) then ui.logsChatColor:set_visible(true)
    else ui.logsChatColor:set_visible(false) end

    if(ui.logsNotifySpeed:get() == 0) then ui.logsNotifySpeed:set(4) end 
    if(ui.logsChatColor:get() == 1) then ui.logsChatColor:set(8) end
end

function BuildMessage(bColored, sType, pNick, hGroup, hChance, aDamage, tBacktrack, isSafe, reason)

    local message = "error"
    local safechat, safe = isSafe
    local color = ui.logsChatColor:get_item_name(ui.logsChatColor:get())
    if(safechat) then safechat = " [{"..color.."}safe{white}]" safe = " [safe]" else safechat = "" safe = "" end

    local prefix = { chat = "", console = "" }
    local sufix = { chat = "", console = "" }

    if(ui.logsTag:get()) then
        if(sType == "Missed") then 
            prefix["chat"] = "* {"..color.."} 空了 {white}[{"..color.."}".. reason .."{white}] "
            sufix["chat"] = " 原因 [{"..color.."}".. reason .. "{white}]"
            prefix["console"] = "空了 [".. reason .."] "
            sufix["console"] = " 原因 [".. reason .. "]"
        end

        if(sType == "Fired at") then 
            prefix["chat"] = "* {"..color.."} 预计命中 {white}[{"..color.."}".. aDamage .."伤害{white}] "
            prefix["console"] = "预计命中 [".. aDamage .."伤害] "
        end

        if(sType == "Hit") then 
            prefix["chat"] = "* {"..color.."} 命中 {white}[{"..color.."}".. aDamage .."伤害{white}] "
            prefix["console"] = "命中 [".. aDamage .."伤害] "
        end
    end

    if(bColored) then message = prefix["chat"] .. ">{"..color.."}> {white} ".. sType .." {"..color.."}" .. pNick .. "{white}的 {"..color.."}" .. hGroup .. " {white}[命中率:{"..color.."}".. hChance .."{white}] [伤害:{"..color.."}" .. aDamage .. "{white}] [bt:{"..color.."}" .. tBacktrack .. "{white}]".. safechat .. sufix["chat"]
    else message = prefix["console"] .. ">> ".. sType .. " " .. pNick .. "的 " .. hGroup .. " [命中率:".. hChance .."] [伤害:" .. aDamage .. "] [bt:" .. tBacktrack .. "]".. safe .. sufix["console"] end
    return message
end

function SendMessage(NotifyHead, Chat, Console)

    if(ui.logsTo:get("左上角")) then client.log_screen(">> " .. Console) end
    if(ui.logsTo:get("通知")) then notifications:add_notification(NotifyHead, Console, ui.logsNotifySpeed:get()) end
    if(ui.logsTo:get("聊天框(本地)")) then chat.print(Chat) end
    if(ui.logsTo:get("聊天框(全局)")) then engine.execute_cmd("say " .. Console) end
    if(ui.logsCopy:get()) then set_clipboard(Console) end
end

--> Aimbot Hit Callback
local function on_aimbot_hit(hit)

    if not ui.logsEnable:get() then return end
    if(ui.logsAimbot:get("命中")) then

        local message = BuildMessage(false, "击中", hit.player:get_name(), data.hitgroupName[hit.aim_hitgroup + 1], hit.aim_hitchance, hit.aim_damage, hit.backtrack_ticks, hit.safepoint, " ")
        local chatmsg = BuildMessage(true, "击中", hit.player:get_name(), data.hitgroupName[hit.aim_hitgroup + 1], hit.aim_hitchance, hit.aim_damage, hit.backtrack_ticks, hit.safepoint, " ")
        SendMessage(">> 击中 " .. hit.player:get_name() .. " 的 " .. data.hitgroupName[hit.aim_hitgroup + 1], chatmsg, message)
    end
end

--> Aimbot Shot Callback
local function on_aimbot_shoot(shot)
    if not ui.logsEnable:get() then return end
    if(ui.logsAimbot:get("预计命中")) then

        local message = BuildMessage(false, "预计命中 ", shot.player:get_name(), data.hitgroupName[shot.hitgroup + 1], shot.hitchance, shot.damage, shot.backtrack_ticks, shot.safepoint, " ")
        local chatmsg = BuildMessage(true, "预计命中 ", shot.player:get_name(), data.hitgroupName[shot.hitgroup + 1], shot.hitchance, shot.damage, shot.backtrack_ticks, shot.safepoint, " ")
        SendMessage(">> 预计命中 " .. shot.player:get_name() .. "的 " .. data.hitgroupName[shot.hitgroup + 1], chatmsg, message)
    end
end

--> Aimbot Miss Callback
local function on_aimbot_miss(miss)

    if not ui.logsEnable:get() then return end

    local reason = miss.reason_string
    if(reason == "spread") then reason = "扩散" end
    if(reason == "resolver") then reason = "解析" end
    if(reason == "spread (missed safe)") then reason = "扩散(安全点)" end
    if(reason == "prediction error") then reason = "预判" end
    if(reason == "server rejection") then reason = "未注册射击" end
    if(reason == "ping (local death)") then reason = "死亡" end
    if(reason == "ping (target death)") then reason = "目标死亡" end
    if(reason == "occlusion") then reason = "遮挡" end

    local message = BuildMessage(false, "空了", miss.player:get_name(), data.hitgroupName[miss.aim_hitgroup + 1], miss.aim_hitchance, miss.aim_damage, miss.backtrack_ticks, miss.aim_safepoint, reason)
    local chatmsg = BuildMessage(true, "空了", miss.player:get_name(), data.hitgroupName[miss.aim_hitgroup + 1], miss.aim_hitchance, miss.aim_damage, miss.backtrack_ticks, miss.aim_safepoint, reason)
    
    if(ui.logsAimbot:get("扩散") and miss.reason_string == "spread" or 
       ui.logsAimbot:get("扩散") and miss.reason_string == "spread (missed safe)" or
       ui.logsAimbot:get("解析") and miss.reason_string == "resolver" or
       ui.logsAimbot:get("预判") and miss.reason_string == "prediction error" or
       ui.logsAimbot:get("未注册") and miss.reason_string == "server rejection" or
       ui.logsAimbot:get("死亡") and miss.reason_string == "ping (local death)" or 
       ui.logsAimbot:get("死亡") and miss.reason_string == "ping (target death)" or
       ui.logsAimbot:get("遮挡") and miss.reason_string == "occlusion" or
       ui.logsAimbot:get("外推") and miss.reason_string == "extrapolation" or
       ui.logsAimbot:get("其他") and not data.missReason[miss.reason_string]) then 

        SendMessage(">> 空枪原因  " .. reason, chatmsg, message)
    end
end

--> Functions for callbacks
callbacks.add(e_callbacks.PAINT, on_paint)
callbacks.add(e_callbacks.AIMBOT_HIT, on_aimbot_hit)
callbacks.add(e_callbacks.AIMBOT_SHOOT, on_aimbot_shoot)
callbacks.add(e_callbacks.AIMBOT_MISS, on_aimbot_miss)

aikoLogs_Init()